Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::ImageCodec Class Reference

Codec specialized in images. More...

`#include <OgreImageCodec.h>`

Inheritance diagram for Ogre::ImageCodec:

[legend]
List of all members.

## Public Types
typedef SharedPtr< CodecData > | CodecDataPtr
typedef ConstMapIterator< CodecList > | CodecIterator
typedef std::pair< MemoryDataStreamPtr, CodecDataPtr > | DecodeResult
| Result of a decoding; both a decoded data stream and CodecData metadata.
## Public Member Functions
virtual | ~ImageCodec ()
String | getDataType () const
| Returns the type of the data that supported by this codec as a String.
virtual DataStreamPtr | code (MemoryDataStreamPtr &input, CodecDataPtr &pData) const =0
| Codes the data in the input stream and saves the result in the output stream.
virtual void | codeToFile (MemoryDataStreamPtr &input, const String &outFileName, CodecDataPtr &pData) const =0
| Codes the data in the input chunk and saves the result in the output filename provided.
virtual DecodeResult | decode (DataStreamPtr &input) const =0
| Codes the data from the input chunk into the output chunk.
virtual String | getType () const =0
| Returns the type of the codec as a String.
## Static Public Member Functions
static void | registerCodec (Codec *pCodec)
| Registers a new codec in the database.
static void | unRegisterCodec (Codec *pCodec)
| Unregisters a codec from the database.
static CodecIterator | getCodecIterator (void)
| Gets the iterator for the registered codecs.
static StringVector | getExtensions (void)
| Gets the file extension list for the registered codecs.
static Codec * | getCodec (const String &extension)
| Gets the codec registered for the passed in file extension.
## Protected Types
typedef std::map< String, Codec * > | CodecList
## Static Protected Attributes
static CodecList | ms_mapCodecs
| A map that contains all the registered codecs.
## Classes
class | ImageData
| Codec return class for images. More...

## Detailed Description

Codec specialized in images.

Remarks:
  The users implementing subclasses of ImageCodec are required to return a valid pointer to a ImageData class from the decode(...) function.

Definition at line 42 of file OgreImageCodec.h.

## Member Typedef Documentation

typedef SharedPtr<CodecData> Ogre::Codec::CodecDataPtr`[inherited]`

| Definition at line 67 of file OgreCodec.h.

typedef ConstMapIterator<CodecList> Ogre::Codec::CodecIterator`[inherited]`

| Definition at line 69 of file OgreCodec.h.

typedef std::map< String, Codec* > Ogre::Codec::CodecList`[protected, inherited]`

| Definition at line 52 of file OgreCodec.h.

typedef std::pair<MemoryDataStreamPtr, CodecDataPtr> Ogre::Codec::DecodeResult`[inherited]`

| Result of a decoding; both a decoded data stream and CodecData metadata. Definition at line 114 of file OgreCodec.h.

## Constructor & Destructor Documentation

virtual Ogre::ImageCodec::~ImageCodec | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual DataStreamPtr Ogre::Codec::code | ( | MemoryDataStreamPtr & | input,
|  | CodecDataPtr & | pData
| ) | const`[pure virtual, inherited]`

| Codes the data in the input stream and saves the result in the output stream. Implemented in Ogre::DDSCodec, Ogre::FreeImageCodec, and Ogre::ILImageCodec.

virtual void Ogre::Codec::codeToFile | ( | MemoryDataStreamPtr & | input,
|  | const String & | outFileName,
|  | CodecDataPtr & | pData
| ) | const`[pure virtual, inherited]`

  | Codes the data in the input chunk and saves the result in the output filename provided. Provided for efficiency since coding to memory is progressive therefore memory required is unknown leading to reallocations. Parameters:
  | input | The input data
  | outFileName | The filename to write to
  | pData | Extra information to be passed to the codec (codec type specific)
Implemented in Ogre::DDSCodec, Ogre::FreeImageCodec, and Ogre::ILImageCodec.

virtual DecodeResult Ogre::Codec::decode | ( | DataStreamPtr & | input | ) | const`[pure virtual, inherited]`

  | Codes the data from the input chunk into the output chunk. Parameters:
  | input | Stream containing the encoded data
Note: Has a variable number of arguments, which depend on the codec type. Implemented in Ogre::DDSCodec, Ogre::FreeImageCodec, and Ogre::ILImageCodec.

static Codec* Ogre::Codec::getCodec | ( | const String & | extension | ) | `[static, inherited]`

| Gets the codec registered for the passed in file extension.

static CodecIterator Ogre::Codec::getCodecIterator | ( | void |  | ) | `[static, inherited]`

| Gets the iterator for the registered codecs. Definition at line 89 of file OgreCodec.h.

String Ogre::ImageCodec::getDataType | ( |  | ) | const`[virtual]`

| Returns the type of the data that supported by this codec as a String. Implements Ogre::Codec. Definition at line 74 of file OgreImageCodec.h.

static StringVector Ogre::Codec::getExtensions | ( | void |  | ) | `[static, inherited]`

| Gets the file extension list for the registered codecs.

virtual String Ogre::Codec::getType | ( |  | ) | const`[pure virtual, inherited]`

| Returns the type of the codec as a String. Implemented in Ogre::DDSCodec, Ogre::FreeImageCodec, and Ogre::ILImageCodec.

static void Ogre::Codec::registerCodec | ( | Codec * | pCodec | ) | `[static, inherited]`

| Registers a new codec in the database. Definition at line 76 of file OgreCodec.h.

static void Ogre::Codec::unRegisterCodec | ( | Codec * | pCodec | ) | `[static, inherited]`

| Unregisters a codec from the database. Definition at line 83 of file OgreCodec.h.

## Member Data Documentation

CodecList Ogre::Codec::ms_mapCodecs`[static, protected, inherited]`

| A map that contains all the registered codecs. Definition at line 55 of file OgreCodec.h.

The documentation for this class was generated from the following file:

- OgreImageCodec.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:46:54 2008